/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Fri Jul  6 15:11:55 2012
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000CE6 (3302)
 *     Revision         0x01
 *     Checksum         0x15
 *     OEM ID           "PmRef"
 *     OEM Table ID     "Cpu0Ist"
 *     OEM Revision     0x00003000 (12288)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20061109 (537268489)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "PmRef", "Cpu0Ist", 0x00003000)
{
    External (TCNT, IntObj)
    External (NPSS, IntObj)
    External (PDC0)
    External (CFGD)
    External (\XECU, IntObj)
    External (\LPST, IntObj)
    External (\CPUC, IntObj)
    External (\DGTP, IntObj)
    External (\TDNV)
    External (\VDSC)
    External (\VIGD)
    External (\CTDP, IntObj)
    External (\PL1M, IntObj)
    External (\PL1L, IntObj)
    External (\MTAU, IntObj)
    External (\PPCR)
    External (\GFPL, IntObj)
    External (\FTPS, IntObj)
    External (\PPCA, IntObj)
    External (\LWST, IntObj)
    External (\TCFD)
    External (\TCFA)
    External (\_PR_.CLVL)
    External (\_PR_.CPU0, DeviceObj)
    External (\_SB_.PCI0.LPC_.IVPW)
    External (\_SB_.PCI0.LPC_.EC__.PSFG, IntObj)
    External (\_SB_.PCI0.LPC_.EC__.PLMS)
    External (\_SB_.PCI0.LPC_.EC__.PLLS)
    External (\_SB_.PCI0.LPC_.EC__.PLTU)
    External (\_SB_.PCI0.LPC_.EC__.PLSL)
    External (\_SB_.PCI0.LPC_.EC__.PIBS, IntObj)
    External (\_SB_.PCI0.PEG_.VID_.CPPC, IntObj)
    External (\_SB_.PCI0.LPC_.EC__.TSL0)
    External (\_SB_.PCI0.LPC_.EC__.LPMD, IntObj)
    External (\_SB_.PCI0.LPC_.EC__.AC__._PSR)

    Scope (\_PR.CPU0)
    {
        Method (_PPC, 0, NotSerialized)
        {
            Store (Zero, Local0)
            Store (\_SB.PCI0.LPC.EC.LPMD, Local0)
            If (LNot (Local0))
            {
                If (LOr (LAnd (\_SB.PCI0.LPC.EC.AC._PSR, \TCFA), LAnd (LNot (\_SB.PCI0.LPC.EC.AC._PSR), \TCFD)))
                {
                    If (And (\_SB.PCI0.LPC.EC.TSL0, 0x76))
                    {
                        Store (\LWST, Local0)
                    }
                }
                Else
                {
                    If (And (\_SB.PCI0.LPC.EC.TSL0, 0x77))
                    {
                        Store (\LWST, Local0)
                    }
                }

                If (LNot (Local0))
                {
                    If (LOr (\PPCA, \FTPS))
                    {
                        If (LLessEqual (\FTPS, \PPCA))
                        {
                            Store (\PPCA, Local0)
                        }
                        Else
                        {
                            Store (\FTPS, Local0)
                        }
                    }
                }
            }

            If (LGreater (\_SB.PCI0.PEG.VID.CPPC, Local0))
            {
                Store (\_SB.PCI0.PEG.VID.CPPC, Local0)
            }

            If (LOr (LAnd (\GFPL, LNot (Local0)), LAnd (LNot (\GFPL), Local0)))
            {
                Store (0x03E8, Local1)
                While (\_SB.PCI0.LPC.EC.PIBS)
                {
                    Sleep (One)
                    Decrement (Local1)
                    If (LNot (Local1))
                    {
                        Store (Local0, \PPCR)
                        Return (Local0)
                    }
                }

                If (Local0)
                {
                    If (LNot (\GFPL))
                    {
                        Store (One, \GFPL)
                        Store (0x04, \_SB.PCI0.LPC.EC.PLSL)
                        Store (One, \_SB.PCI0.LPC.EC.PLTU)
                        Store (0x0D, \_SB.PCI0.LPC.EC.PLLS)
                        Store (Zero, \_SB.PCI0.LPC.EC.PLMS)
                    }
                }
                Else
                {
                    If (\GFPL)
                    {
                        Store (Zero, \GFPL)
                        Store (0x04, \_SB.PCI0.LPC.EC.PLSL)
                        If (\MTAU)
                        {
                            Store (\MTAU, \_SB.PCI0.LPC.EC.PLTU)
                        }
                        Else
                        {
                            Store (0x1C, \_SB.PCI0.LPC.EC.PLTU)
                        }

                        Store (\PL1L, \_SB.PCI0.LPC.EC.PLLS)
                        Store (\PL1M, \_SB.PCI0.LPC.EC.PLMS)
                    }
                }
            }

            If (LEqual (\_PR.CLVL, 0x03))
            {
                If (LEqual (Local0, Zero))
                {
                    If (LNotEqual (\CTDP, Zero))
                    {
                        Store (\CTDP, Local0)
                    }
                }
                Else
                {
                    If (LGreaterEqual (\CTDP, Local0))
                    {
                        Store (\CTDP, Local0)
                        If (LGreater (\LWST, Local0))
                        {
                            Increment (Local0)
                        }
                    }
                }
            }
            Else
            {
            }

            If (\_SB.PCI0.LPC.EC.PSFG)
            {
                If (LAnd (LEqual (\VIGD, One), LEqual (\VDSC, Zero)))
                {
                    Noop
                }
                Else
                {
                    If (LOr (\TDNV, \_SB.PCI0.LPC.IVPW))
                    {
                        If (\DGTP)
                        {
                            If (\CPUC)
                            {
                                Store (0x05, Local0)
                            }
                            Else
                            {
                                Store (\LPST, Local0)
                            }
                        }
                        Else
                        {
                            If (\XECU)
                            {
                                Store (\LPST, Local0)
                            }
                            Else
                            {
                                If (\CPUC)
                                {
                                    Store (0x02, Local0)
                                }
                                Else
                                {
                                    Store (0x05, Local0)
                                }
                            }
                        }
                    }
                    Else
                    {
                        Noop
                    }
                }
            }

            Store (Local0, \PPCR)
            Return (Local0)
        }

        Method (_PCT, 0, NotSerialized)
        {
            If (LAnd (And (CFGD, One), And (PDC0, One)))
            {
                Return (Package (0x02)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW, 
                            0x00,               // Bit Width
                            0x00,               // Bit Offset
                            0x0000000000000000, // Address
                            ,)
                    }, 

                    ResourceTemplate ()
                    {
                        Register (FFixedHW, 
                            0x00,               // Bit Width
                            0x00,               // Bit Offset
                            0x0000000000000000, // Address
                            ,)
                    }
                })
            }

            Return (Package (0x02)
            {
                ResourceTemplate ()
                {
                    Register (SystemIO, 
                        0x10,               // Bit Width
                        0x00,               // Bit Offset
                        0x0000000000000800, // Address
                        ,)
                }, 

                ResourceTemplate ()
                {
                    Register (SystemIO, 
                        0x08,               // Bit Width
                        0x00,               // Bit Offset
                        0x00000000000000B3, // Address
                        ,)
                }
            })
        }

        Method (XPSS, 0, NotSerialized)
        {
            If (And (PDC0, One))
            {
                Return (NPSS)
            }

            Return (SPSS)
        }

        Name (SPSS, Package (0x10)
        {
            Package (0x06)
            {
                0x00000A8D, 
                0x0000AFC8, 
                0x0000006E, 
                0x0000000A, 
                0x00000083, 
                0x00000000
            }, 

            Package (0x06)
            {
                0x00000A8C, 
                0x0000AFC8, 
                0x0000006E, 
                0x0000000A, 
                0x00000183, 
                0x00000001
            }, 

            Package (0x06)
            {
                0x00000A28, 
                0x0000A6D4, 
                0x0000006E, 
                0x0000000A, 
                0x00000283, 
                0x00000002
            }, 

            Package (0x06)
            {
                0x000009C4, 
                0x00009E0D, 
                0x0000006E, 
                0x0000000A, 
                0x00000383, 
                0x00000003
            }, 

            Package (0x06)
            {
                0x00000960, 
                0x00009571, 
                0x0000006E, 
                0x0000000A, 
                0x00000483, 
                0x00000004
            }, 

            Package (0x06)
            {
                0x000008FC, 
                0x00008EAD, 
                0x0000006E, 
                0x0000000A, 
                0x00000583, 
                0x00000005
            }, 

            Package (0x06)
            {
                0x00000898, 
                0x00008661, 
                0x0000006E, 
                0x0000000A, 
                0x00000683, 
                0x00000006
            }, 

            Package (0x06)
            {
                0x00000834, 
                0x00007E47, 
                0x0000006E, 
                0x0000000A, 
                0x00000783, 
                0x00000007
            }, 

            Package (0x06)
            {
                0x0000076C, 
                0x0000701A, 
                0x0000006E, 
                0x0000000A, 
                0x00000883, 
                0x00000008
            }, 

            Package (0x06)
            {
                0x00000708, 
                0x00006870, 
                0x0000006E, 
                0x0000000A, 
                0x00000983, 
                0x00000009
            }, 

            Package (0x06)
            {
                0x000006A4, 
                0x000060EF, 
                0x0000006E, 
                0x0000000A, 
                0x00000A83, 
                0x0000000A
            }, 

            Package (0x06)
            {
                0x00000640, 
                0x00005B26, 
                0x0000006E, 
                0x0000000A, 
                0x00000B83, 
                0x0000000B
            }, 

            Package (0x06)
            {
                0x000005DC, 
                0x000053F1, 
                0x0000006E, 
                0x0000000A, 
                0x00000C83, 
                0x0000000C
            }, 

            Package (0x06)
            {
                0x00000578, 
                0x00004CE3, 
                0x0000006E, 
                0x0000000A, 
                0x00000D83, 
                0x0000000D
            }, 

            Package (0x06)
            {
                0x00000514, 
                0x0000477A, 
                0x0000006E, 
                0x0000000A, 
                0x00000E83, 
                0x0000000E
            }, 

            Package (0x06)
            {
                0x000004B0, 
                0x000040B6, 
                0x0000006E, 
                0x0000000A, 
                0x00000F83, 
                0x0000000F
            }
        })
        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Name (_PSS, Package (0x10)
        {
            Package (0x06)
            {
                0x00000A8D, 
                0x0000AFC8, 
                0x0000000A, 
                0x0000000A, 
                0x0000FF00, 
                0x0000FF00
            }, 

            Package (0x06)
            {
                0x00000A8C, 
                0x0000AFC8, 
                0x0000000A, 
                0x0000000A, 
                0x00001B00, 
                0x00001B00
            }, 

            Package (0x06)
            {
                0x00000A28, 
                0x0000A6D4, 
                0x0000000A, 
                0x0000000A, 
                0x00001A00, 
                0x00001A00
            }, 

            Package (0x06)
            {
                0x000009C4, 
                0x00009E0D, 
                0x0000000A, 
                0x0000000A, 
                0x00001900, 
                0x00001900
            }, 

            Package (0x06)
            {
                0x00000960, 
                0x00009571, 
                0x0000000A, 
                0x0000000A, 
                0x00001800, 
                0x00001800
            }, 

            Package (0x06)
            {
                0x000008FC, 
                0x00008EAD, 
                0x0000000A, 
                0x0000000A, 
                0x00001700, 
                0x00001700
            }, 

            Package (0x06)
            {
                0x00000898, 
                0x00008661, 
                0x0000000A, 
                0x0000000A, 
                0x00001600, 
                0x00001600
            }, 

            Package (0x06)
            {
                0x00000834, 
                0x00007E47, 
                0x0000000A, 
                0x0000000A, 
                0x00001500, 
                0x00001500
            }, 

            Package (0x06)
            {
                0x0000076C, 
                0x0000701A, 
                0x0000000A, 
                0x0000000A, 
                0x00001300, 
                0x00001300
            }, 

            Package (0x06)
            {
                0x00000708, 
                0x00006870, 
                0x0000000A, 
                0x0000000A, 
                0x00001200, 
                0x00001200
            }, 

            Package (0x06)
            {
                0x000006A4, 
                0x000060EF, 
                0x0000000A, 
                0x0000000A, 
                0x00001100, 
                0x00001100
            }, 

            Package (0x06)
            {
                0x00000640, 
                0x00005B26, 
                0x0000000A, 
                0x0000000A, 
                0x00001000, 
                0x00001000
            }, 

            Package (0x06)
            {
                0x000005DC, 
                0x000053F1, 
                0x0000000A, 
                0x0000000A, 
                0x00000F00, 
                0x00000F00
            }, 

            Package (0x06)
            {
                0x00000578, 
                0x00004CE3, 
                0x0000000A, 
                0x0000000A, 
                0x00000E00, 
                0x00000E00
            }, 

            Package (0x06)
            {
                0x00000514, 
                0x0000477A, 
                0x0000000A, 
                0x0000000A, 
                0x00000D00, 
                0x00000D00
            }, 

            Package (0x06)
            {
                0x000004B0, 
                0x000040B6, 
                0x0000000A, 
                0x0000000A, 
                0x00000C00, 
                0x00000C00
            }
        })
        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Name (PSDF, Zero)
        Method (_PSD, 0, NotSerialized)
        {
            If (LNot (PSDF))
            {
                Store (TCNT, Index (DerefOf (Index (HPSD, Zero)), 0x04))
                Store (TCNT, Index (DerefOf (Index (SPSD, Zero)), 0x04))
                Store (Ones, PSDF)
            }

            If (And (PDC0, 0x0800))
            {
                Return (HPSD)
            }

            Return (SPSD)
        }

        Name (HPSD, Package (0x01)
        {
            Package (0x05)
            {
                0x05, 
                Zero, 
                Zero, 
                0xFE, 
                0x80
            }
        })
        Name (SPSD, Package (0x01)
        {
            Package (0x05)
            {
                0x05, 
                Zero, 
                Zero, 
                0xFC, 
                0x80
            }
        })
    }
}

